//CNC router hardware revision v0.6
//
//Code to run on the host computer see:
//commands-CNC.c
//
//Source & info: http://www.HomoFaciens.de/technics-machines-cnc-v0-6_en_navion.htm


//#include <avr/io.h>
//#include <util/delay.h>
#include <Servo.h> 

//Change values below to adapt your motor

#define STEP_MARGIN      1L    //10 - 1000 (2)
#define MIN_DUTYCYCLE    75    //0 - 255 (125)
#define MAX_DUTYCYCLE   155    //0 - 255 (255)

#define MotY_SENSOR_1     4    //Photo sensor 1
#define MotY_SENSOR_2     5    //Photo sensor 2
#define MotY_DIRECTION   12    //Direction output motor
#define MotY_PWM         11    //PWM output motor

#define MotX_SENSOR_1     2    //Photo sensor 1
#define MotX_SENSOR_2     3    //Photo sensor 2
#define MotX_DIRECTION    7    //Direction output motor
#define MotX_PWM          6    //PWM output motor

#define SERVO_Z          10    //Servo Z axis

#define RELAY            13    //Relay used to turn on milling machine


int MotYSensor02 = 0;
int MotYSensor01 = 0;
int MotYDutyCycle = 100; // 10 - 255
long MotYSetPoint = 0;
long MotYIsPoint = 0;
byte MotYStep = 0;
byte MotYStepDone = 0;

int MotXSensor02 = 0;
int MotXSensor01 = 0;
int MotXDutyCycle = 100; // 10 - 255
long MotXSetPoint = 0;
long MotXIsPoint = 0;
byte MotXStep = 0;
byte MotXStepDone = 0;

byte readByte = 0;

Servo ServoZ;
int ServoZSetPoint = 90;


unsigned long stepTime = 1;

unsigned long millisStart = 0;


void establishContact() {
  while (Serial.available() <= 0) {
    Serial.print('X');   // send a capital X
    delay(300);
  }
}

void setup(){ 

  pinMode(RELAY, OUTPUT);
  digitalWrite(RELAY, 0);
  

  pinMode(MotY_DIRECTION, OUTPUT);     
  pinMode(MotY_PWM, OUTPUT);     
  analogWrite(MotY_PWM, 0);
  digitalWrite(MotY_DIRECTION, 0);
  
  pinMode(MotY_SENSOR_1, INPUT);
  pinMode(MotY_SENSOR_2, INPUT);
  
  pinMode(MotX_DIRECTION, OUTPUT);     
  pinMode(MotX_PWM, OUTPUT);     
  analogWrite(MotX_PWM, 0);
  digitalWrite(MotX_DIRECTION, 0);
  
  pinMode(MotX_SENSOR_1, INPUT);
  pinMode(MotX_SENSOR_2, INPUT);
  
  stepTime = 1;
  readByte = 0;
  
  MotYStep = 0;
  MotXStep = 0;

  MotYStepDone = 1;
  MotXStepDone = 1;
  

  MotYSetPoint = 0;
  MotYIsPoint  = 0;

  MotXSetPoint = 0;
  MotXIsPoint =  0;

  ServoZSetPoint = 90;
  ServoZ.attach(SERVO_Z);
  ServoZ.write(ServoZSetPoint);
  delay(15);
  // start serial port at 115200 bps:
  Serial.begin(115200);
  establishContact();  // send a byte to establish contact until receiver responds 
}


void loop(){  

  millisStart = millis();
  while(millis() - millisStart < stepTime){
    do{

      MotYSensor01 = digitalRead(MotY_SENSOR_1);
      MotYSensor02 = digitalRead(MotY_SENSOR_2);
    
      if(MotYSensor02 == 0 && MotYSensor01 == 0){
        if(MotYStep == 1){
          MotYIsPoint--;
        }
        if(MotYStep == 3){
          MotYIsPoint++;
        }
        MotYStep = 0;
      }
    
      if(MotYSensor02 == 1 && MotYSensor01 == 0){
        if(MotYStep == 0){
          MotYIsPoint++;
        }
        if(MotYStep == 2){
          MotYIsPoint--;
        }
        MotYStep = 1;
      }
    
      if(MotYSensor02 == 1 && MotYSensor01 == 1){
        if(MotYStep == 3){
          MotYIsPoint--;
        }
        if(MotYStep == 1){
          MotYIsPoint++;
        }
        MotYStep = 2;
      }
    
      if(MotYSensor02 == 0 && MotYSensor01 == 1){
        if(MotYStep == 2){
          MotYIsPoint++;
        }
        if(MotYStep == 0){
          MotYIsPoint--;
        }
        MotYStep = 3;
      }

      if(abs(MotYSetPoint - MotYIsPoint) < STEP_MARGIN){
        analogWrite(MotY_PWM, 0);
        digitalWrite(MotY_DIRECTION, 0);
        MotYStepDone = 1;
        MotYDutyCycle = MIN_DUTYCYCLE;
      }
      else{
        if(MotYIsPoint < MotYSetPoint){
          digitalWrite(MotY_DIRECTION, 1);
          analogWrite(MotY_PWM, 255 - MotYDutyCycle);
        }
        if(MotYIsPoint > MotYSetPoint){
          digitalWrite(MotY_DIRECTION, 0);
          analogWrite(MotY_PWM, MotYDutyCycle);
        }
      }

      MotXSensor01 = digitalRead(MotX_SENSOR_1);
      MotXSensor02 = digitalRead(MotX_SENSOR_2);
    
      if(MotXSensor02 == 0 && MotXSensor01 == 0){
        if(MotXStep == 1){
          MotXIsPoint--;
        }
        if(MotXStep == 3){
          MotXIsPoint++;
        }
        MotXStep = 0;
      }
    
      if(MotXSensor02 == 1 && MotXSensor01 == 0){
        if(MotXStep == 0){
          MotXIsPoint++;
        }
        if(MotXStep == 2){
          MotXIsPoint--;
        }
        MotXStep = 1;
      }
    
      if(MotXSensor02 == 1 && MotXSensor01 == 1){
        if(MotXStep == 3){
          MotXIsPoint--;
        }
        if(MotXStep == 1){
          MotXIsPoint++;
        }
        MotXStep = 2;
      }
    
      if(MotXSensor02 == 0 && MotXSensor01 == 1){
        if(MotXStep == 2){
          MotXIsPoint++;
        }
        if(MotXStep == 0){
          MotXIsPoint--;
        }
        MotXStep = 3;
      }

      if(abs(MotXSetPoint - MotXIsPoint) < STEP_MARGIN){
        analogWrite(MotX_PWM, 0);
        digitalWrite(MotX_DIRECTION, 0);
        MotXStepDone = 1;
        MotXDutyCycle = MIN_DUTYCYCLE;
      }
      else{
        if(MotXIsPoint < MotXSetPoint){
          digitalWrite(MotX_DIRECTION, 1);
          analogWrite(MotX_PWM, 255 - MotXDutyCycle);
        }
        if(MotXIsPoint > MotXSetPoint){
          digitalWrite(MotX_DIRECTION, 0);
          analogWrite(MotX_PWM, MotXDutyCycle);
        }
      }
      
    }while(MotYStepDone == 0 || MotXStepDone == 0);
    if(readByte == 0){
      millisStart = 0L;
    }
  }//while(millis() - millisStart < stepTime){
  
  readByte = 0;
  if (Serial.available() > 0){//if we get a valid byte, read from serial:
    //get incoming byte:
    readByte = Serial.read();
    Serial.print('r');   // send a 'r' to initiate next data from computer
  }//if (Serial.available() > 0){


  
  if(readByte > 0){
    if(readByte == 255){
      digitalWrite(RELAY, 1);
      readByte = 0;
    }
    if(readByte == 254){
      digitalWrite(RELAY, 0);
      readByte = 0;
    }

    if(readByte == 128){
      if(stepTime < 1000){
        stepTime+=10;
      }
    }
    if(readByte == 64){
      if(stepTime > 10){
        stepTime-=10;
      }
    }
    if(readByte == 32){
      if(ServoZSetPoint > 0){
        ServoZSetPoint--;
      }
      ServoZ.write(ServoZSetPoint);
//      delay(15);      
    }
    if(readByte == 16){
      if(ServoZSetPoint < 180){
        ServoZSetPoint++;
      }
      ServoZ.write(ServoZSetPoint);
//      delay(15);
    }
    if(readByte == 8){
      MotYSetPoint++;
      MotYDutyCycle = MAX_DUTYCYCLE;
      MotYStepDone = 0;
    }
    if(readByte == 4){
      MotYSetPoint--;
      MotYDutyCycle = MAX_DUTYCYCLE;
      MotYStepDone = 0;
    }
    if(readByte == 2){
      MotXSetPoint++;
      MotXDutyCycle = MAX_DUTYCYCLE;
      MotXStepDone = 0;
    }
    if(readByte == 1){
      MotXSetPoint--;
      MotXDutyCycle = MAX_DUTYCYCLE;
      MotXStepDone = 0;
    }
      
  }//if(readByte > 0){

}


